<template>
  <div class="province-selector">
    <p class="province-selector__selector-label">Provincia</p>
    <q-field
      filled
      item-aligned
      bg-color="secondary"
      class="province-selector cursor-pointer"
      bottom-slots
      :error="UIdataModel.length === 0"
      :error-message="'Seleccione al menos una provincia'"
      :disable="isFetching"
    >
      <template v-slot:default>
        <div v-if="!allPicked" class="full-width row q-py-xs justify-left items-center">
          <q-chip
            v-for="item in UIdataModel"
            :key="item"
            :label="normalizeNames(item, 'region')"
            dense
            ripple
            color="white"
            text-color="primary"
          />
        </div>
        <div v-if="allPicked" class="full-width row justify-left items-center">
          Todas
        </div>
        <q-menu
          @before-show="popupStateToggle(true)"
          @before-hide="popupStateToggle(false)"
          @hide="updateModelValue()"
          fit
          anchor="bottom right"
          self="top right"
          max-height='50vh'
          :disable="isFetching"
        >
          <div class="q-pa-md">
            <q-checkbox
              v-model="allPicked"
              @update:model-value="pickAll()"
              label="Todas"
              checked-icon='radio_button_checked'
              unchecked-icon="radio_button_unchecked"
              size="lg"
              :disable="isFetching"
            />
            <q-option-group
              v-model="UIdataModel"
              :options="options"
              type="checkbox"
              size="lg"
              :disable="isFetching"
            >
            </q-option-group>
          </div>
        </q-menu>

      </template>

      <template v-slot:append>
        <q-icon
          name="expand_more"
          size="5vh"
          color="primary"
          class="cursor-pointer transition-expand"
          :class="isPopupShow ? 'rotate' : ''"
        />
      </template>

      <template v-if="UIdataModel.length !== 0" v-slot:hint>
        <q-btn :disable="isFetching" icon="close" rounded size="sm" @click="cleanSelection()">Limpiar la selección</q-btn>
      </template>

      <template v-if="UIdataModel.length === 0" v-slot:error />
    </q-field>
  </div>
</template>

<script setup>
import { ref, watchEffect, computed } from 'vue';
import { ecProvincias, provinciasDefaultSelect } from 'src/data/common-constants';
import normalizeNames from 'src/composables/get_normalized_name';


const props = defineProps({
  modelValue: {
    type: Array,
    required: true,
  },
  isFetching: {
    type: Boolean,
    required: true
  }
});

const emit = defineEmits(['update:modelValue']);

const localModel = computed({
  get: () => props?.modelValue,
  set: () => updateModelValue()
});

let UIdataModel;
let allPicked;

const updateModelValue = () => {
  emit("update:modelValue", UIdataModel.value)
};

const options = ecProvincias
const isPopupShow = ref(false)

const pickAll = () => {
  if (UIdataModel.value.length === 24) {
    UIdataModel.value = [];
    switchPickedAllValue(false);
  } else {
    UIdataModel.value = provinciasDefaultSelect;
    switchPickedAllValue(true);
  }
}

const popupStateToggle = (state) => isPopupShow.value = state;

const cleanSelection = () => UIdataModel.value = [];

const switchPickedAllValue = (state) => allPicked.value = state;

watchEffect(() => {
  UIdataModel = ref([...localModel.value]);
  allPicked = computed({
    get: () => UIdataModel.value.length === 24,
    set: () => {},
  });
});

</script>

<style lang="scss">
@use './multiple-choice-selector-component-stylesheet.scss';
</style>